Pyramid Hierarchy in JavaScript

Using ApexCharts with JavaScript

This Pyramid Hierarchy example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
var options = {
  series: [576, 168, 42, 34],
  chart: {
    type: 'unit',
    height: 470,
    animations: {
      enabled: true,
      speed: 900,
    },
  },
  labels: ['Individual contributors', 'Team leads', 'Directors', 'Executives'],
  // The tiers are ordered, so the palette climbs - but it turns hue as it goes
  // rather than only getting darker, because four tints of one colour are close to
  // indistinguishable at this dot size. The apex is the darkest tier.
  colors: ['#F7C948', '#F0883E', '#D64545', '#2E4A62'],
  plotOptions: {
    unit: {
      layout: 'custom',
      // One of the shapes in apexcharts/unit-shapes.
      positions: 'pyramid',
      transition: 'flow',
      clusterLabels: {
        // A labelled pyramid: each tier is named beside itself, so the reader
        // never has to count dots against a legend.
        external: {
          show: true,
        },
      },
    },
  },
  legend: {
    show: false,
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Pyramid Hierarchy in React

Using ApexCharts with React

This Pyramid Hierarchy example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

// This demo also loads: https://cdn.jsdelivr.net/npm/apexcharts/dist/unit-shapes.js

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [576, 168, 42, 34],
    options: {
      chart: {
        type: 'unit',
        height: 470,
        animations: {
          enabled: true,
          speed: 900,
        },
      },
      labels: [
        'Individual contributors',
        'Team leads',
        'Directors',
        'Executives',
      ],
      // The tiers are ordered, so the palette climbs - but it turns hue as it goes
      // rather than only getting darker, because four tints of one colour are close to
      // indistinguishable at this dot size. The apex is the darkest tier.
      colors: ['#F7C948', '#F0883E', '#D64545', '#2E4A62'],
      plotOptions: {
        unit: {
          layout: 'custom',
          // One of the shapes in apexcharts/unit-shapes.
          positions: 'pyramid',
          transition: 'flow',
          clusterLabels: {
            // A labelled pyramid: each tier is named beside itself, so the reader
            // never has to count dots against a legend.
            external: {
              show: true,
            },
          },
        },
      },
      legend: {
        show: false,
      },
    },
  })

  return (
    <div>
      <div className="wrap">
        <h1>820 people, 34 of them executives</h1>
        <p>
          Not an outline but a lattice: tier one holds one dot, tier two holds
          two, and so on, so the dots cut the slope themselves and every tier is
          a real count. Filled from the base, a head count turns into the
          hierarchy it describes, which no rectangular layout can show.
        </p>

        <div className="chart-wrap">
          <div id="chart">
            <ReactApexChart
              options={state.options}
              series={state.series}
              type="unit"
              height={470}
            />
          </div>
        </div>

        <p className="note">1 dot = 1 person</p>
      </div>
    </div>
  )
}

export default ApexChart

Pyramid Hierarchy in Angular

Using ApexCharts with Angular

This Pyramid Hierarchy example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  public chartOptions: Partial<ChartOptions> = {
          series: [576, 168, 42, 34],
          chart: {
            type: 'unit',
            height: 470,
            animations: {
              enabled: true,
              speed: 900,
            },
          },
          labels: ['Individual contributors', 'Team leads', 'Directors', 'Executives'],
          // The tiers are ordered, so the palette climbs - but it turns hue as it goes
          // rather than only getting darker, because four tints of one colour are close to
          // indistinguishable at this dot size. The apex is the darkest tier.
          colors: ['#F7C948', '#F0883E', '#D64545', '#2E4A62'],
          plotOptions: {
            unit: {
              layout: 'custom',
              // One of the shapes in apexcharts/unit-shapes.
              positions: 'pyramid',
              transition: 'flow',
              clusterLabels: {
                // A labelled pyramid: each tier is named beside itself, so the reader
                // never has to count dots against a legend.
                external: {
                  show: true,
                },
              },
            },
          },
          legend: {
            show: false,
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

Pyramid Hierarchy in Vue

Using ApexCharts with Vue

This Pyramid Hierarchy example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div class="wrap">
      <h1>820 people, 34 of them executives</h1>
      <p>
        Not an outline but a lattice: tier one holds one dot, tier two holds
        two, and so on, so the dots cut the slope themselves and every tier is a
        real count. Filled from the base, a head count turns into the hierarchy
        it describes, which no rectangular layout can show.
      </p>

      <div class="chart-wrap">
        <div id="chart">
          <apexchart
            type="unit"
            height="470"
            :options="chartOptions"
            :series="series"
          ></apexchart>
        </div>
      </div>

      <p class="note">1 dot = 1 person</p>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

// This demo also loads: https://cdn.jsdelivr.net/npm/apexcharts/dist/unit-shapes.js

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [576, 168, 42, 34],
      chartOptions: {
        chart: {
          type: 'unit',
          height: 470,
          animations: {
            enabled: true,
            speed: 900,
          },
        },
        labels: [
          'Individual contributors',
          'Team leads',
          'Directors',
          'Executives',
        ],
        // The tiers are ordered, so the palette climbs - but it turns hue as it goes
        // rather than only getting darker, because four tints of one colour are close to
        // indistinguishable at this dot size. The apex is the darkest tier.
        colors: ['#F7C948', '#F0883E', '#D64545', '#2E4A62'],
        plotOptions: {
          unit: {
            layout: 'custom',
            // One of the shapes in apexcharts/unit-shapes.
            positions: 'pyramid',
            transition: 'flow',
            clusterLabels: {
              // A labelled pyramid: each tier is named beside itself, so the reader
              // never has to count dots against a legend.
              external: {
                show: true,
              },
            },
          },
        },
        legend: {
          show: false,
        },
      },
    }
  },
}
</script>

<style>
body {
  font-family:
    -apple-system, BlinkMacSystemFont, 'Segoe UI', Roboto, sans-serif;
  background: #fafbfc;
  color: #2c3e50;
  margin: 0;
  padding: 32px 16px;
}
.wrap {
  max-width: 720px;
  margin: 0 auto;
}
h1 {
  font-size: 22px;
  margin: 0 0 8px;
}
p {
  color: #5b6b78;
  line-height: 1.5;
  margin: 0 0 24px;
}
.chart-wrap {
  background: #fff;
  border-radius: 8px;
  padding: 16px;
  box-shadow: 0 2px 10px rgba(0, 0, 0, 0.04);
}
.note {
  color: #8592a0;
  font-size: 12px;
  text-align: center;
  margin: 16px 0 0;
}
</style>